using System;

 //From user's point of view the first day has number 1 because
 //its index has been adjusted for the zero based index and the
 //the first hour has number 0. So days has indexes from 1-7,
 //hours has indexes from 0-23
class CarCounter
{
    private int [,] hourCarCounts = new int [7,24];
    
    public CarCounter()
    {
         //Initialize all hourCarCounts elements to zero
        for(int i = 0; i < 7; i++)
        {
            for(int j = 0; j < 24; j++)
            {
                hourCarCounts[i,j] = 0;
            }
        }
    }
    
     //Display a menu, 
     //let the user enter a command and respond accordingly
    public void Run()
    {
        string answer;
        
        Console.WriteLine("I Input another value");
        Console.WriteLine("G Get count for specific hour");
        Console.WriteLine("S Calculate the total cars counted");
        Console.WriteLine("H Calculate number of hours to reach a given car count");
        Console.WriteLine("T Terminate");
        
        do
        {
            Console.Write("\nPlease choose an option: ");
            answer = Console.ReadLine().ToUpper();
            
            switch(answer)
            {
                case "I":
                    InputCarCount();
                break;
                case "G":
                    GetHourCount();
                break;
                case "S":
                    Console.WriteLine("The total number of cars counted {0}", TotalCarsCounted());
                break;
                case "H":
                    HoursToReachCount();
                break;
                case "T":
                    Console.WriteLine("Bye Bye!");
                break;
                default:
                    Console.WriteLine("Invalid reply. Please try again");
                
                break;
            }  
        } while (answer != "T");
    }
    
     //Let the user input a car count into a given day and hour
    public void InputCarCount()
    {
        int day;
        int hour;
        int carCount;
        
        Console.Write("Input day: ");
        day = Convert.ToInt32(Console.ReadLine());
        Console.Write("Input hour: ");
        hour = Convert.ToInt32(Console.ReadLine());
        Console.Write("Input car count: ");
        carCount = Convert.ToInt32(Console.ReadLine());
         // 1 is deducted from day in the next line to adjust
         // for zero based index
        hourCarCounts[day - 1,hour] = carCount;
    }
     
     //Finds the car count of a specific day and hour   
    public void GetHourCount()
    {
        int day;
        int hour;
        
        Console.Write("Enter day: ");
        day = Convert.ToInt32(Console.ReadLine());
        Console.Write("Enter hour: ");
        hour = Convert.ToInt32(Console.ReadLine());
         // 1 is deducted from day in the next line to adjust
         // for zero based index
        Console.WriteLine("Car count: {0}", hourCarCounts[day - 1, hour]);
    }
    
     //Finds the sum of all hourly car counts in hourCarCounts    
    public int TotalCarsCounted()
    {
        int sum = 0;
            
        foreach(int temp in hourCarCounts)
        {
            sum += temp;
        }
        return sum;
    }
    
     //Calculates the hours it takes to reach a given car count
    public void HoursToReachCount()
    {
        int reachCarCounts = 0;
        int hourCount = 0;
        int sumCarCounts = 0;
        
        Console.Write("Input number of cars to be reached: ");
        reachCarCounts = Convert.ToInt32(Console.ReadLine());
            
        for(int i = 0; i < 7; i++)
        {
            for(int j = 0; j < 24; j++)
            {
                hourCount++;
                sumCarCounts += hourCarCounts[i,j];
                if(sumCarCounts > reachCarCounts)
                {
                    Console.WriteLine("Number of hours: {0}", hourCount);
                    return;
                }
            }
        }
        Console.WriteLine("The given count: {0} was never reached", reachCarCounts);
    }
}

class Tester
{
    public static void Main()
    {
        CarCounter myCarCounter = new CarCounter();
        myCarCounter.Run();
    }
}

