using System;

public interface IComparable
{
    int CompareTo(IComparable comp);
}

public class Account : IComparable
{
    private decimal balance;
    
    public Account(decimal initBalance)
    {
        balance = initBalance;
    }
    
    public decimal Balance
    {
        get
        {
            return balance;
        }

        set
        {
            balance = value;
        }
    }
    
    public virtual int CompareTo(IComparable comp)
    {
        Account compareAccount = (Account) comp;
        
        if(balance > compareAccount.Balance)
            return 1;
        else if(compareAccount.Balance == balance)
            return 0;
        else
            return -1;
    }
}

class Sorter
{
     // Sort the comparable elements of an array in ascending order    
    public static void BubbleSortAscending(IComparable [] bubbles)
    {
        bool swapped = true;
        
        for (int i = 0; swapped; i++)
        {
            swapped = false;
            for (int j = 0; j < (bubbles.Length - (i + 1)); j++)
            {
                if (bubbles[j].CompareTo(bubbles[j + 1]) > 0)
                {
                    Swap(j, j + 1, bubbles);
                    swapped = true;
                }    
            }
        }
    }
    
     //Swap two elements of an array
    public static void Swap(int first, int second, IComparable [] arr)
    {
        IComparable temp;
        
        temp = arr[first];
        arr[first] = arr[second];
        arr[second] = temp;
    }
}

class Tester
{
    public static void Main()
    {       
        Account [] accounts = new Account[4];
        
        accounts[0] = new Account(100);
        accounts[1] = new Account(200);
        accounts[2] = new Account(50);
        accounts[3] = new Account(75);
        
        Sorter.BubbleSortAscending(accounts);

        foreach(Account tempAccount in accounts)
        {
            Console.WriteLine(tempAccount.Balance);
        }
    }
}

