using System;

class Meteorologist
{
    private int[] rainfall;
    private int[] pollution;
    
    public Meteorologist()
    {
        rainfall = new int[12];
        pollution = new int[12];
        
         //Assign an arbitrary number to each
         //rainfall and pollution element. 
         //In this case rainfall is set to
         //i * 5 and pollution to i + 10
        for(int i = 0; i < 12; i++)
        {
            rainfall[i] = i * 5;
            pollution[i] = i + 10;
        }
    }

    public int GetRainfall(int index)
    {
        try
        {
            return rainfall[index];
        }
        catch(IndexOutOfRangeException exObj)
        {
            Console.WriteLine("The index must be between 0 and 11"); 
            Console.WriteLine(exObj.Message);
            return -1;
        }       
    }
    
    public int GetAveragePollution(int index)
    {
        Console.WriteLine("Opening WeatherXYZ file");
        try
        {
            return pollution[index] / rainfall[index];
        }
        catch(IndexOutOfRangeException exObj)
        {
            Console.WriteLine("The index must be between 0 and 11");
            Console.WriteLine(exObj.Message);
            return -1;
        }
        catch(DivideByZeroException exObj)
        {
            Console.WriteLine("The rainfall element was zero");
            Console.WriteLine(exObj.Message);
            return -1;
        }
        finally
        {
            Console.WriteLine("Closing WeatherXYZ file");
        }
    }
}

class Tester
{
    public static void Main()
    {
        Meteorologist aMeteorologist = new Meteorologist();
        Console.WriteLine("Rainfall in January: {0}", aMeteorologist.GetRainfall(0));
         //Triggering IndexOutOfRangeException
        Console.WriteLine("Rainfall next year: {0}", aMeteorologist.GetRainfall(13));
         //Triggering DivideByZeroException
        Console.WriteLine("Average pollution: {0}", aMeteorologist.GetAveragePollution(0));
    }
}

