using System;

class Car
{
    private int position = 0;
    
    public void MoveForward(int distance)
    {
        position += distance;
    }
    
    public void Reverse(int distance)
    {
        position -= distance;
    }

    public int GetPosition()
    {
        return position;
    }    
}

class CarGame
{
    private Car [] cars;
    
    public CarGame()
    {
        cars = new Car [5];
        for(int i = 0; i < cars.Length; i++)
        {
            cars[i] = new Car();
        }
    }
    
    public int GetCarPosition(int carIndex)
    {
        return cars[carIndex].GetPosition();
    }

    public void MoveCarForward(int carIndex, int distance)
    {
        cars[carIndex].MoveForward(distance);
    }
    
    public void ReverseCar(int carIndex, int distance)
    {
        cars[carIndex].Reverse(distance);
    }
}

class CarGameTester
{
    public static void Main()
    {
        CarGame testGame = new CarGame();
        testGame.MoveCarForward(0, 100);
        testGame.MoveCarForward(1, 40);
        Console.WriteLine("Position of car 0: {0}", testGame.GetCarPosition(0));
        Console.WriteLine("Position of car 1: {0}", testGame.GetCarPosition(1));
    }
}
