using System;
 
delegate string DoStringProcessing(string text);
 
class CharacterProcessor
{
    private DoStringProcessing[] processingList;
    private int stringProcessingCounter;
     
    public CharacterProcessor()
    {
        stringProcessingCounter = 0;
        processingList = new DoStringProcessing[20];
    }
     
    public void AddStringOperation(DoStringProcessing newStringProcess)
    {
        processingList[stringProcessingCounter] = newStringProcess;
        stringProcessingCounter++;
    }
     
    public string StartProcessing(string tempString)
    {
        Console.WriteLine("Start string: " + tempString);   
        for (int i = 0; i < stringProcessingCounter; i++)
        {
            tempString = processingList[i](tempString);       
        }
        return tempString;
    }
}
 
class StringOperator
{
    public static DoStringProcessing DoAddA = new DoStringProcessing(AddA);
    public static DoStringProcessing DoAddB = new DoStringProcessing(AddB);
    public static DoStringProcessing DoAddC = new DoStringProcessing(AddC);
 
    public static string AddA(string text)
    {
        Console.WriteLine("Add A to string");
        return text + "A";
    }
     
    public static string AddB(string text)
    {
        Console.WriteLine("Add B to string");
        return text + "B";
    }
    
    public static string AddC(string text)
    {
        Console.WriteLine("Add C to string");
        return text + "C";
    }  
}

public class Tester
{
    public static void Main()
    {
        string startText;
        string endResult;
        string response;
        
        CharacterProcessor processor = new CharacterProcessor();
        
        Console.Write("Enter start string: ");
        startText = Console.ReadLine();
        Console.WriteLine("Create sequence of operations by repeatedly");
        Console.WriteLine("choosing from the following options");
        Console.WriteLine("A) Add A");
        Console.WriteLine("B) Add B");
        Console.WriteLine("C) Add C");
        Console.WriteLine("When you wish to perform the processing enter P\n");
        
        do
        {
            response = Console.ReadLine().ToUpper();
            switch(response)
            {
                case "A":
                    processor.AddStringOperation(StringOperator.DoAddA);
                    Console.WriteLine("Add A operation added");
                break;
                case "B":
                    processor.AddStringOperation(StringOperator.DoAddB);
                    Console.WriteLine("Add B operation added");
                break;
                case "C":
                    processor.AddStringOperation(StringOperator.DoAddC);
                    Console.WriteLine("Add C operation added");
                break;
                case "P":
                    endResult = processor.StartProcessing(startText);
                    Console.WriteLine("End result: {0}", endResult);
                break;
                default:
                    Console.WriteLine("Invalid choice please try again");
                break;
            }
        } while (response != "P");
    }
}

