using System;

class BoxOfNumbers
{
    private int [,,] numbers = new int [5,10,8];
    
    public BoxOfNumbers()
    {
         //Initialize all numbers
        for(int i = 0; i < 5; i++)
        {
            for(int j = 0; j < 10; j++)
            {
                for(int k = 0; k < 8; k++)
                { 
                    numbers[i,j,k] = 0;
                }
            }
        }
    }
    
     //Display a menu, 
     //let the user enter a command and respond accordingly
    public void Run()
    {
        string answer;
        
        Console.WriteLine("I Input another number");
        Console.WriteLine("G Get number for specific indexes");
        Console.WriteLine("S Calculate the sum of the numbers");
        Console.WriteLine("T Terminate");
        
        do
        {
            Console.Write("\nPlease choose an option: ");
            answer = Console.ReadLine().ToUpper();
            
            switch(answer)
            {
                case "I":
                    InputNumber();
                break;
                case "G":
                    GetNumber();
                break;
                case "S":
                    Console.WriteLine("Sum of all numbers {0}", NumbersSum());
                break;
                case "T":
                    Console.WriteLine("Bye Bye!");
                break;
                default:
                    Console.WriteLine("Invalid reply. Please try again");
                break;
            }  
        } while (answer != "T");
    }
    
     //Lets the user input a number for a given set of indexes
    public void InputNumber()
    {
        int indexDimension1;
        int indexDimension2;
        int indexDimension3;
        int number;
        
        Console.Write("Enter index for 1st dimension: ");
        indexDimension1 = Convert.ToInt32(Console.ReadLine());
        Console.Write("Enter index for 2nd dimension: ");
        indexDimension2 = Convert.ToInt32(Console.ReadLine());
        Console.Write("Enter index for 3rd dimension ");
        indexDimension3 = Convert.ToInt32(Console.ReadLine());
        Console.Write("Enter number: ");
        number = Convert.ToInt32(Console.ReadLine());
        numbers[indexDimension1, indexDimension2, indexDimension3] = number;
    }
     
     //Finds and displays the number for a given set of indexes   
    public void GetNumber()
    {
        int indexDimension1;
        int indexDimension2;
        int indexDimension3;
        
        Console.Write("Enter index dimension 1: ");
        indexDimension1 = Convert.ToInt32(Console.ReadLine());
        Console.Write("Enter index dimension 2: ");
        indexDimension2 = Convert.ToInt32(Console.ReadLine());
        Console.Write("Enter index dimension 3: ");
        indexDimension3 = Convert.ToInt32(Console.ReadLine());
        Console.WriteLine("Number: {0}", 
            numbers[indexDimension1, indexDimension2, indexDimension3]);
    }
    
     //Finds the sum of all numbers    
    public int NumbersSum()
    {
        int sum = 0;
            
        foreach(int temp in numbers)
        {
            sum += temp;
        }
        return sum;
    }
}

class Tester
{
    public static void Main()
    {
        BoxOfNumbers myNumberBox = new BoxOfNumbers();
        myNumberBox.Run();
    }
}


