using System;

class BliposClock
{
     //A time in the BliposClock is represented by just one value: totalSeconds.
     //All displayed times are derived from this basic value.
    private ulong totalSeconds;

    public BliposClock()
    {
        totalSeconds = 0;
    }
  
    public void AddSeconds(ulong secondsToAdd)
    {
        totalSeconds = totalSeconds + secondsToAdd;
    }
    
    public void DeductSeconds(ulong secondsToDeduct)
    {
        totalSeconds = totalSeconds - secondsToDeduct;
    }

     //initialMinutes can be between -32768 and 32767 so to convert this value
     //to totalSeconds we must add 32768 and multiply by 256 before we add this
     //value to initialSeconds as shown in the statement of the following method.
    public void SetTime(byte initialSeconds, short initialMinutes)
    {
        totalSeconds = (ulong)initialSeconds + (ulong)((initialMinutes + 32768) * 256);
    }

    public void ShowTime()
    {
        byte secondsToShow;
        int secondsPassedBy; // Total number of seconds the day is old
        short minutesToShow;
        
        secondsToShow = (byte)(totalSeconds % 256);
        secondsPassedBy = (int)(totalSeconds % (256 * 65536));
         //By dividing secondsPassedBy by 256 in the next line we find the
         //number of whole minutes the day is old. This number can be
         //between 0 and 65535. However we need a number
         // between -32768 and 32767, which we can get by
         //subtracting 32768 as shown in the next line.
        minutesToShow = (short) ((secondsPassedBy / 256) - 32768);
    
        Console.WriteLine("Sec: {0}  Min: {1}", secondsToShow, minutesToShow); 
    }
}

class RunBliposClock
{
    public static void Main()
    {
        string command;
        byte tempSeconds;
        short tempMinutes;

        Console.WriteLine("Welcome to the Blipos Clock. " +
            "256 seconds per minute " +
            "65536 minutes per day");
        BliposClock myClock = new BliposClock();
        Console.WriteLine("Please set the clock");
        Console.Write("Enter Seconds: ");
        tempSeconds = Convert.ToByte(Console.ReadLine());
        Console.Write("Enter minutes: ");
        tempMinutes = Convert.ToInt16(Console.ReadLine());
        myClock.SetTime(tempSeconds, tempMinutes);
        
        Console.WriteLine("Enter (F)orward (B)ackward " +
            "(A)dd fifty (D)educt fifty (T)erminate");
        do
        {
            command = Console.ReadLine().ToUpper();
            if (command == "F")
                myClock.AddSeconds(1);
            if (command == "B")
                myClock.DeductSeconds(1);
            if(command == "A")
                myClock.AddSeconds(50);
            if(command == "D")
                myClock.DeductSeconds(50);
            myClock.ShowTime();
        } while (command != "T");
        Console.WriteLine("Thank you for using the Blipos Clock");
    }
}
