using System;

abstract class Employee
{
    public abstract void CalculateSalary();
}

class Secretary : Employee, IStorable
{
    public override void CalculateSalary()
    {
        Console.WriteLine("Calculate salary for secretary");
    }
    
    public void Read()
    {
        Console.WriteLine("Now reading secretary");
    }
    
    public void Write()
    {
        Console.WriteLine("Now writing secretary");
    }
}

class Director : Employee
{
    public override void CalculateSalary()
    {
        Console.WriteLine("Calculate salary for director");
    }
}

class Programmer : Employee
{
    public override void CalculateSalary()
    {
        Console.WriteLine("Calculate salary for programmer");
    }
}

interface IStorable
{
    void Read();
    void Write();
}

class Building
{
    private int age;
    private decimal currentValue;
    
}

class House : Building, IStorable
{
    private ushort numberOfBedrooms;
    
    public void Read()
    {
        Console.WriteLine("Now reading house");
    }
    
    public void Write()
    {
        Console.WriteLine("Now writing house");
    }
}

class OfficeBuilding
{
    private uint floorSpace;

}

class Tester
{
    public static void Main()
    {
        House myHouse = new House();
        Secretary mySecretary = new Secretary();
        
        Transfer(myHouse);
        Transfer(mySecretary);
    }
    
    public static void Transfer (IStorable tempStore)
    {
        tempStore.Read();
        tempStore.Write();
    }
}
